﻿namespace UltraGridCalcManager
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(), "ProductGroups");
            this.ultraGrid1.Rows.ExpandAll(true);
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable productGroup = ds.Tables.Add("ProductGroups");
            productGroup.Columns.Add("Id", typeof(int)).AutoIncrement = true;
            productGroup.Columns.Add("Group Name", typeof(string));
            productGroup.Columns.Add("Rolled Up Quantity", typeof(int));

            DataTable products = ds.Tables.Add("Products");
            products.Columns.Add("GroupId", typeof(int));
            products.Columns.Add("Name", typeof(string));
            products.Columns.Add("Quantity", typeof(int));
            products.Columns.Add("Status", typeof(Status));


            ds.Relations.Add(productGroup.Columns["Id"], products.Columns["GroupId"]);

            ds = this.AddData(ds);

            return ds;
        }

        private DataSet AddData(DataSet ds)
        {
            ds.Tables["ProductGroups"].Rows.Add(new object[] { null, "Product Group A", 0});
            ds.Tables["ProductGroups"].Rows.Add(new object[] { null, "Product Group B", 0 });

            ds.Tables["Products"].Rows.Add(new object[] { 0, "Product 1", 20, Status.StatusA });
            ds.Tables["Products"].Rows.Add(new object[] { 0, "Product 2", 30, Status.StatusB });
            ds.Tables["Products"].Rows.Add(new object[] { 0, "Product 3", 10, Status.StatusA });
            ds.Tables["Products"].Rows.Add(new object[] { 0, "Product 4", 55, Status.StatusB });
            ds.Tables["Products"].Rows.Add(new object[] { 1, "Product 5", 15, Status.StatusA });
            ds.Tables["Products"].Rows.Add(new object[] { 1, "Product 6", 25, Status.StatusB });
            ds.Tables["Products"].Rows.Add(new object[] { 1, "Product 7", 80, Status.StatusB });
            ds.Tables["Products"].Rows.Add(new object[] { 1, "Product 8", 40, Status.StatusA });

            return ds;
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[1].Override.AllowRowFiltering = DefaultableBoolean.True;
            //e.Layout.Grid.CalcManager = this.ultraCalcManager1;
            //e.Layout.Bands[0].Columns["Rolled Up Quantity"].Formula = string.Format("sum ([{0}])", e.Layout.Bands[1].Columns["Quantity"].FormulaAbsoluteName);

        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Band.Index == 0)
            {
                this.RecalcValues(e.Row);
            }
        }

        private void UltraGrid1_AfterRowFilterChanged(object sender, AfterRowFilterChangedEventArgs e)
        {
            this.RecalcValues(e.Rows.ParentRow);
        }

        private void RecalcValues(UltraGridRow parentRow)
        {
            int sum = 0;
            foreach (UltraGridRow row in parentRow.ChildBands[0].Rows)
            {
                if (!row.IsFilteredOut)
                {
                    // Add additional custom logic here
                    sum += (int)row.Cells[2].Value; 
                }
            }

            parentRow.Cells[2].Value = sum;
        }
    }
}
